import type { SSRRenderInstruction, SSRResult } from '../../../@types/astro';
import type { AstroComponentFactory } from './index';
export declare class AstroComponent {
    private htmlParts;
    private expressions;
    constructor(htmlParts: TemplateStringsArray, expressions: any[]);
    get [Symbol.toStringTag](): string;
    [Symbol.asyncIterator](): AsyncGenerator<any, void, undefined>;
}
export declare function isAstroComponent(obj: any): obj is AstroComponent;
export declare function renderAstroComponent(component: InstanceType<typeof AstroComponent>): AsyncIterable<string | SSRRenderInstruction>;
export declare function renderToString(result: SSRResult, componentFactory: AstroComponentFactory, props: any, children: any): Promise<string>;
export declare function renderToIterable(result: SSRResult, componentFactory: AstroComponentFactory, displayName: string, props: any, children: any): Promise<AsyncIterable<string | SSRRenderInstruction>>;
export declare function renderTemplate(htmlParts: TemplateStringsArray, ...expressions: any[]): Promise<AstroComponent>;
